package Service;


import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class JsoupUtils {
    public void getBook(String url, int section) throws IOException {
        if (Jsoup.connect(url).execute().statusCode() == 200) {
            Document doc = Jsoup.connect(url).get();
            String bookName = doc.title();
            Elements links = doc.select("#j-catalogWrap > div.volume-wrap");
            Elements contentUrl = links.select("a");
            List<String> urls = contentUrl.stream().map(element -> element.attr("abs:href")).collect(Collectors.toList());
            List<String> titles = new ArrayList<>();
            List<Integer> words_number = new ArrayList<>();
            for (String a : urls) {
                if (a.contains("vipreader")) {
                    System.out.println("剩下的是vip章节了");
                    break;
                } else if (a.contains("chapter")) {
                    Document mo = Jsoup.connect(a).get();
                    String id = mo.getElementsByClass("text-wrap").attr("id");
                    System.out.println(id);
                    Elements title = mo.select("#" + id + " > div > div.text-head > h3 > span.content-wrap");
                    Elements content = mo.select("#" + id + " > div > div.read-content.j_readContent");
                    String tit = title.text();
                    String con = content.text();
                    if (!tit.equals("")) {
                        titles.add(tit);
                        words_number.add(con.length());
                    } else {
                        continue;
                    }
                    downBook(bookName, tit, con, section);

                } else {
                    section++;
                }

            }
            if (!titles.isEmpty()) {
                conclusion(bookName,titles,words_number);
            }
        } else {
            return;
        }

    }

    //获得从x卷到y卷
    public void getBook(int start, int end, String url) throws IOException {
        Document doc = Jsoup.connect(url).get();
        String bookName = doc.title();
        Elements links = doc.select("#j-catalogWrap > div.volume-wrap");
        Elements contentUrl = links.select("a");
        List<String> urls = contentUrl.stream().map(element -> element.attr("abs:href")).collect(Collectors.toList());
        List<String> titles = new ArrayList<>();
        List<Integer> words_number = new ArrayList<>();
        for (String a : urls) {
            if (a.contains("chapter")) {
                Document mo = Jsoup.connect(a).get();
                String id = mo.getElementsByClass("text-wrap").attr("id");
                System.out.println(id);
                Elements title = mo.select("#" + id + " > div > div.text-head > h3 > span.content-wrap");
                Elements content = mo.select("#" + id + " > div > div.read-content.j_readContent");
                String tit = title.text();
                String con = content.text();
                if (!tit.equals("")) {
                    titles.add(tit);
                    words_number.add(con.length());
                } else {
                    continue;
                }

                downBook(bookName, tit, con, start - 1);

            } else {
                start++;
                if (start == end) {
                    conclusion(bookName,titles,words_number);
                    return;
                }
            }

        }
    }

    private static void downBook(String bookName2, String title, String content, int section) {

        File file = new File("D:/book.qidian/" + "#" + bookName2);

        if (!file.exists()) {

            //如果不存在目录，则创建目录
            file.mkdirs();
        }

        PrintWriter pw = null;
        try {

            FileOutputStream fos = new FileOutputStream("D:/book.qidian/" + "#" + bookName2 + "/" + "第" + section + "卷" + title + ".txt");

            pw = new PrintWriter(fos, true);

            pw.println(content);

            System.out.println(title + "  " + "爬取完毕");

        } catch (FileNotFoundException e) {
            e.printStackTrace();
            return;

        } finally {//关流
            pw.close();
        }
    }

    private static void conclusion(String bookName2, List<String> titles, List<Integer> words_number) {

        File file = new File("D:/book.qidian/" + "#" + bookName2);

        PrintWriter pw = null;
        try {

            FileOutputStream fos = new FileOutputStream("D:/book.qidian/" + "#" + bookName2 + "/" + "conclusion" + ".txt");

            pw = new PrintWriter(fos, true);

            for (int i = 0; i < titles.size(); i++) {
                pw.println(titles.get(i));
                pw.println(words_number.get(i));
            }


        } catch (FileNotFoundException e) {
            e.printStackTrace();
            return;

        } finally {//关流
            pw.close();
        }
    }
}

